# encoding: utf-8

module RSeed
  module Utils
    extend self

    def treePath path
      tree = {}
      if File.directory? path
        Dir.entries(path).sort!.each do |file|
          if file != "." and file != ".."
            if File.directory?(File.join(path, file))
              tree[file] = treePath(File.join(path, file))
            else
              tree[file] = :file
            end
          end
        end
      else 
        tree = { "#{path}" => :file }
      end
      tree
    end

    def renderTree tree, hash
      s = "<ul>"
      tree.each do |node|
        if node == :file or node[1] == :file
          s += "<li><a href='/d/#{hash}/#{node[0]}'>#{node[0]}</a></li>"
        else
          s += "<li>#{node[0]}/"
          s += renderTree(node[1], hash)
          s += "</li>"
        end
      end
      s += "</ul>"
      s
    end

  end
end
